﻿using System;
using System.Drawing;
using System.Windows.Forms;
using DllMapK;

namespace MapAppSample
{
	public partial class CIconAddDlg : Form
	{
		internal CMapKObject MapKObject;



		public CIconAddDlg(PointDouble _P)
		{
			InitializeComponent();

			MapKObject = new CMapKObject();
			MapKObject.Type = Object_TYPE.ICON;                    // アイコン
			MapKObject.P = _P;

			RB_Icon1.Checked = true;
			TB_IconSize.Text = "1";
			TB_Label.Text = "TEST";
			RB_MSゴシック9.Checked = true;
			RB_アイコンの下.Checked = true;
			RB_中央.Checked = true;
			RB_背景有り.Checked = true;
			PB_文字色.BackColor = Color.Red;
			PB_背景色.BackColor = Color.Yellow;
		}

		private void B_OK_Click(object sender, EventArgs e)
		{
			try {
				String IconName = null;
				if (RB_Icon1.Checked == true) {
					IconName = "Icon1";
				}
				else if (RB_Icon2.Checked == true) {
					IconName = "Icon2";
				}
				else if (RB_Icon3.Checked == true) {
					IconName = "Icon3";
				}
				else if (RB_Icon4.Checked == true) {
					IconName = "Icon4";
				}
				else if (RB_Icon5.Checked == true) {
					IconName = "Icon5";
				}
				else if (RB_Icon6.Checked == true) {
					IconName = "Icon6";
				}
				else if (RB_Icon7.Checked == true) {
					IconName = "Icon7";
				}
				else if (RB_Icon8.Checked == true) {
					IconName = "Icon8";
				}
				if (String.IsNullOrEmpty(IconName) == false) {
					MapKObject.Icon = (Icon)Properties.Resources.ResourceManager.GetObject(IconName);
					MapKObject.IconSize = Convert.ToSingle(TB_IconSize.Text);
					MapKObject.Label = TB_Label.Text;                               // ラベル
					if (RB_MSゴシック9.Checked == true) {                           // フォント
						MapKObject.LabelFont = new Font("MS ゴシック", 9, FontStyle.Bold);
					}
					else {
						MapKObject.LabelFont = new Font("MS ゴシック", 12, FontStyle.Bold);
					}
					MapKObject.LabelPosition = RB_アイコンの中.Checked;               // ラベル位置
					MapKObject.LabelCenter = RB_中央.Checked;						  // ラベル位置
					MapKObject.LabelBkStyle = RB_背景有り.Checked;				      // ラベル背景スタイル
					MapKObject.LabelLineColor = PB_文字色.BackColor;			      // ラベル色
					MapKObject.LabelBkColor = PB_背景色.BackColor;				      // ラベル背景色

					DialogResult = DialogResult.OK;
					return;
				}
			}
			catch {
			}
			MessageBox.Show("不正な設定です。");
		}

		private void B_文字色選択_Click(object sender, EventArgs e)
		{
			CColorSelect.Select(PB_文字色);
		}

		private void B_背景色選択_Click(object sender, EventArgs e)
		{
			CColorSelect.Select(PB_背景色);
		}
	}
}

