﻿using System;
using System.Drawing;
using System.Windows.Forms;
using DllMapK;

namespace MapAppSample
{
	public partial class CLabelAddDlg: Form
    {
		internal CMapKObject MapKObject;



		public CLabelAddDlg(PointDouble _P)
		{
			InitializeComponent();

			MapKObject = new CMapKObject();
			MapKObject.Type = Object_TYPE.LABEL;                    // ラベル
			MapKObject.P = _P;

			TB_Label.Text = "TEST";
			RB_MSゴシック9.Checked = true;
			RB_中央.Checked = true;
			RB_背景有り.Checked = true;
			PB_文字色.BackColor = Color.Red;
			PB_背景色.BackColor = Color.Yellow;
		}

		private void B_OK_Click(object sender, EventArgs e)
		{
			if (String.IsNullOrEmpty(TB_Label.Text) == false) {
				MapKObject.Label = TB_Label.Text;                               // ラベル
				MapKObject.LabelCenter = true;
				if (RB_MSゴシック9.Checked == true) {                           // フォント
					MapKObject.LabelFont = new Font("MS ゴシック", 9, FontStyle.Bold);
				}
				else {
					MapKObject.LabelFont = new Font("MS ゴシック", 12, FontStyle.Bold);
				}
				MapKObject.LabelCenter = RB_中央.Checked;                       // ラベル位置
				MapKObject.LabelBkStyle = RB_背景有り.Checked;                  // ラベル背景スタイル
				MapKObject.LabelLineColor = PB_文字色.BackColor;                // ラベル色
				MapKObject.LabelBkColor = PB_背景色.BackColor;					// ラベル背景色

				DialogResult = DialogResult.OK;
			}
			else {
				MessageBox.Show("不正な設定です。");
			}
		}

		private void B_文字色選択_Click(object sender, EventArgs e)
		{
			CColorSelect.Select(PB_文字色);
		}

		private void B_背景色選択_Click(object sender, EventArgs e)
		{
			CColorSelect.Select(PB_背景色);
		}
	}
}
