using System;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Windows.Forms;
using DllMapK;

namespace MapAppSample
{
	public partial class MainForm : Form, IMapK
	{
		PointDouble InitLocation;
		double InitScale;

		EMouseModes MouseMode = EMouseModes.MM_TOOLBAL_NULL;
		Cursor CursorZoomIn = new Cursor(new MemoryStream(Properties.Resources.CursorZoomIn));
		Cursor CursorGraber = new Cursor(new MemoryStream(Properties.Resources.CursorGraber));
		Cursor CursorMapHelp = new Cursor(new MemoryStream(Properties.Resources.CursorMapHelp));
		Cursor CursorIconSet = new Cursor(new MemoryStream(Properties.Resources.CursorIconSet));
		Cursor CursorLineSet = new Cursor(new MemoryStream(Properties.Resources.CursorLineSet));
		Cursor CursorLabelSet = new Cursor(new MemoryStream(Properties.Resources.CursorLabelSet));
		Cursor CursorLineSelect = new Cursor(new MemoryStream(Properties.Resources.CursorLineSelect));

		bool SetLineStartLocation = false;
		PointDouble LineStartLocation;



		public MainForm()
		{
			InitializeComponent();

			PB_MainMap.SetScaleView(true);

			if (MapKMapOpen(true) == false) {
				MessageBox.Show("n}J܂łBI܂B");
				Environment.Exit(0);
			}
			InitLocation = PB_MainMap.GetCenter();
			InitScale = PB_MainMap.GetZoom();
			MouseModeSet(EMouseModes.MM_TOOLBAR_SELECT);
		}

		//------------------------------------------------------
		//		c[o[̑IԂ̕\
		//------------------------------------------------------
		internal void TSBSet()
		{
			TBB_MapZoomIn.Pushed = (MouseMode == EMouseModes.MM_TOOLBAR_ZOOMIN);
			TBB_MapGrabber.Pushed = (MouseMode == EMouseModes.MM_TOOLBAR_GRABBER);
			TBB_Select.Pushed = (MouseMode == EMouseModes.MM_TOOLBAR_SELECT);
			TBB_MapHelp.Pushed = (MouseMode == EMouseModes.MM_TOOLBAR_POINTVIEW);
			TBB_IconSet.Pushed = (MouseMode == EMouseModes.MM_TOOLBAR_ICONSET);
			TBB_LineSet.Pushed = (MouseMode == EMouseModes.MM_TOOLBAR_LINESET);
			TBB_LabelSet.Pushed = (MouseMode == EMouseModes.MM_TOOLBAR_LABELSET);
		}
		//------------------------------------------------------
		//		n}ǉ
		//------------------------------------------------------
		private void MI_n}̒ǉ_Click(object sender, EventArgs e)
		{
			MapKMapOpen(false);
		}

		//------------------------------------------------------
		//		n}iinit@CjJ
		//------------------------------------------------------
		internal bool MapKMapOpen(bool WithIni)
		{
			OpenFileDialog dlg = new OpenFileDialog();
			dlg.Title = "n} ini t@CJ";
			dlg.Filter = "ini files (*.ini)|*.ini";
			if (dlg.ShowDialog() == DialogResult.OK) {
				String MapFileName = dlg.FileName;
				if (MapFileName.EndsWith(".ini") == true) {
					MapFileName = MapFileName.Substring(0, MapFileName.Length - 4);
					if (PB_MainMap.MapFileOpen(this, MapFileName, "", WithIni) == true) {
						return (true);
					}
				}
			}
			return (false);
		}

		//------------------------------------------------------
		//		n}\ɖ߂
		//------------------------------------------------------
		internal void SetMapHome()
		{
			PB_MainMap.SetCenter(InitLocation);
			PB_MainMap.SetZoom(InitScale);
			PB_MainMap.Refresh();
		}

		//------------------------------------------------------
		//		IMapK C^[tFCX֐
		//		MapK ̒n}\ύXʒm
		//------------------------------------------------------
		public void MapK_MapChange()
		{
			// n}XVƂ̊֐Ă΂B
			// n}XVɕKvȏ͂ɋLqB

			PointDouble MapCenter = PB_MainMap.GetCenter();
			Text = "MapAppSample  (" + MapCenter.X.ToString("F4") + " / " + MapCenter.Y.ToString("F4") + ")";
		}

		//------------------------------------------------------
		//		IMapK C^[tFCX֐
		//		n}ł̃}EXNbN
		//------------------------------------------------------
		public void MapK_MouseClick(PointDouble P, MouseButtons button)
		{
			switch (button) {
			case MouseButtons.Left:                         // {^
				switch (MouseMode) {
				case EMouseModes.MM_TOOLBAR_SELECT:             //	ACR/xIuWFNgI[h
					{
						List<CSelectMapObject> SelectObject = PB_MainMap.SearchObject(P);
						if (SelectObject.Count > 0) {
							CMapObjectView dlg = new CMapObjectView(SelectObject[0]);
							if (dlg.ShowDialog() == DialogResult.OK) {
							}
						}
					}
					break;

				case EMouseModes.MM_TOOLBAR_LINESELECT:         //	CIuWFNgI[h
					if (SetLineStartLocation == false) {
						LineStartLocation = P;
						SetLineStartLocation = true;
					}
					else {
						PB_MainMap.DeleteMapObject(1000);
						PB_MainMap.DeleteMapObject(1001);
						PB_MainMap.DeleteMapObject(1002);
						PB_MainMap.DeleteMapObject(1003);
						SetLineStartLocation = false;
						List<CSelectMapObject> SelectObject = PB_MainMap.SearchLineObject(LineStartLocation, P, true);
						if (SelectObject.Count > 0) {
							CMapObjectView dlg = new CMapObjectView(SelectObject[0]);
							if (dlg.ShowDialog() == DialogResult.OK) {
							}
						}
						PB_MainMap.Refresh();
					}
					break;

				case EMouseModes.MM_TOOLBAR_ZOOMIN:				//	g僂[h
					PB_MainMap.SetCenter(P);
					PB_MainMap.MapZoom(2);
					PB_MainMap.Refresh();
					break;

				case EMouseModes.MM_TOOLBAR_GRABBER:			//	n}̈ړ
					this.Cursor = new Cursor(new MemoryStream(Properties.Resources.CursorGraber));
					break;

				case EMouseModes.MM_TOOLBAR_POINTVIEW:          //	}EXʒȕ\
					{
						CClickPointView dlg = new CClickPointView(P);
						dlg.ShowDialog();
					}
					break;

				case EMouseModes.MM_TOOLBAR_ICONSET:            //	ACRIuWFNg̒ǉ
					{
						CIconAddDlg dlg = new CIconAddDlg(P);
						if (dlg.ShowDialog() == DialogResult.OK) {
							if (PB_MainMap.AddMapObject(dlg.MapKObject) == true) {
								PB_MainMap.Refresh();
							}
						}
					}
					break;

				case EMouseModes.MM_TOOLBAR_LINESET:            //	CIuWFNg̒ǉ
					if (SetLineStartLocation == false) {
						LineStartLocation = P;
						SetLineStartLocation = true;
					}
					else {
						PB_MainMap.DeleteMapObject(100);
						SetLineStartLocation = false;
						CLineAddDlg dlg = new CLineAddDlg(LineStartLocation, P);
						if (dlg.ShowDialog() == DialogResult.OK) {
							if (PB_MainMap.AddMapObject(dlg.MapKObject) == true) {
							}
						}
						PB_MainMap.Refresh();
					}
					break;

				case EMouseModes.MM_TOOLBAR_LABELSET:			//	xIuWFNg̒ǉ
						{
						CLabelAddDlg dlg = new CLabelAddDlg(P);
						if (dlg.ShowDialog() == DialogResult.OK) {
							if (PB_MainMap.AddMapObject(dlg.MapKObject) == true) {
								PB_MainMap.Refresh();
							}
						}
					}
					break;
				}
				return;

			case MouseButtons.Right:						//	E{^
				switch (MouseMode) {
				case EMouseModes.MM_TOOLBAR_ZOOMIN:				//	g僂[h
					PB_MainMap.MapZoom(0.5F);
					PB_MainMap.Refresh();
					break;
				}
				return;
			}
		}

		public void MapK_MouseMove(PointDouble P, MouseButtons button)
		{
			if (SetLineStartLocation == true) {
				if (button == MouseButtons.None) {
					switch (MouseMode) {
					case EMouseModes.MM_TOOLBAR_LINESET:             //	CIuWFNg̒ǉ
						SetLineObject(100, LineStartLocation, P);
						PB_MainMap.Refresh();
						break;
					case EMouseModes.MM_TOOLBAR_LINESELECT:         //	CIuWFNgI[h
						PointF S1 = PB_MainMap.MapToSrc(LineStartLocation);
						PointF S2 = PB_MainMap.MapToSrc(P);
						PointDouble P12 = PB_MainMap.SrcToMap(new PointDouble(S1.X, S2.Y));
						PointDouble P21 = PB_MainMap.SrcToMap(new PointDouble(S2.X, S1.Y));
						SetLineObject(1000, LineStartLocation, P12);
						SetLineObject(1001, LineStartLocation, P21);
						SetLineObject(1002, P, P12);
						SetLineObject(1003, P, P21);
						PB_MainMap.Refresh();
						break;
					}
				}
			}
		}

		private void SetLineObject(int ID, PointDouble P1, PointDouble P2)
		{
			CMapKObject MapKObject = new CMapKObject();
			MapKObject.Type = Object_TYPE.LINE;                    // C
			MapKObject.ID = ID;
			MapKObject.P = P1;
			MapKObject.P2 = P2;
			MapKObject.LabelLineColor = Color.Red;

			PB_MainMap.ChgMapObject(MapKObject);
		}

		//------------------------------------------------------
		//		c[o[̑I
		//------------------------------------------------------
		private void TB_ToolBar_ButtonClick(object sender, ToolBarButtonClickEventArgs e)
		{
			String Name = e.Button.Name;

			if (Name == "TBB_MapHome") {						//	n}̃z[|WVւ̈ڍs
				SetMapHome();
				MouseModeSet(EMouseModes.MM_TOOLBAR_SELECT);
			}
			else if (Name == "TBB_MapZoomIn") {					//	n}̊g
				MouseModeSet(EMouseModes.MM_TOOLBAR_ZOOMIN);
			}
			else if (Name == "TBB_MapGrabber") {				//	n}̈ړ
				MouseModeSet(EMouseModes.MM_TOOLBAR_GRABBER);
			}
			else if (Name == "TBB_Select") {					//	ACR/xIuWFNg̑I
				MouseModeSet(EMouseModes.MM_TOOLBAR_SELECT);
			}
			else if (Name == "TBB_LineSelect") {				//	CIuWFNg̑I
				MouseModeSet(EMouseModes.MM_TOOLBAR_LINESELECT);
				SetLineStartLocation = false;
			}
			else if (Name == "TBB_MapHelp") {					//	}EXʒȕ\
				MouseModeSet(EMouseModes.MM_TOOLBAR_POINTVIEW);
			}
			else if (Name == "TBB_IconSet") {                   //	ACRIuWFNg̒ǉ
				MouseModeSet(EMouseModes.MM_TOOLBAR_ICONSET);
			}
			else if (Name == "TBB_LineSet") {                   //	CIuWFNg̒ǉ
				MouseModeSet(EMouseModes.MM_TOOLBAR_LINESET);
				SetLineStartLocation = false;
			}
			else if (Name == "TBB_LabelSet") {                  //	xIuWFNg̒ǉ
				MouseModeSet(EMouseModes.MM_TOOLBAR_LABELSET);
			}
		}

		internal void MouseModeSet(EMouseModes _MouseMode)
		{
			if (MouseMode != _MouseMode) {
				MouseMode = _MouseMode;

				PB_MainMap.SetMapMoveMode(MouseMode == EMouseModes.MM_TOOLBAR_GRABBER);

				TSBSet();
				switch (MouseMode) {
				case EMouseModes.MM_TOOLBAR_ZOOMIN:			//	n}̊g
					Cursor = CursorZoomIn;
					break;
				case EMouseModes.MM_TOOLBAR_GRABBER:		//	n}̈ړ
					Cursor = CursorGraber;
					break;
				case EMouseModes.MM_TOOLBAR_SELECT:         //	ACR/xIuWFNg̑I
					Cursor = Cursors.Default;
					break;
				case EMouseModes.MM_TOOLBAR_LINESELECT:
					Cursor = CursorLineSelect;
					break;
				case EMouseModes.MM_TOOLBAR_POINTVIEW:		//	}EXʒȕ\
					Cursor = CursorMapHelp;
					break;
				case EMouseModes.MM_TOOLBAR_ICONSET:		//	ACRIuWFNg̒ǉ
					Cursor = CursorIconSet;
					break;
				case EMouseModes.MM_TOOLBAR_LINESET:		//	CIuWFNg̒ǉ
					Cursor = CursorLineSet;
					break;
				case EMouseModes.MM_TOOLBAR_LABELSET:		//	xIuWFNg̒ǉ
					Cursor = CursorLabelSet;
					break;
				}
			}
		}

		//------------------------------------------------------
		//		Map 
		//------------------------------------------------------
		private void MainForm_KeyDown (object sender, KeyEventArgs e)
		{
			switch (e.KeyData) {
			case Keys.Home:
				SetMapHome();
				MouseModeSet(EMouseModes.MM_TOOLBAR_SELECT);
				PB_MainMap.Refresh();
				break;

			case Keys.PageUp:
				PB_MainMap.MapZoom(2);
				PB_MainMap.Refresh();
				break;

			case Keys.PageDown:
				PB_MainMap.MapZoom(0.5F);
				PB_MainMap.Refresh();
				break;

			case Keys.Up:
				PB_MainMap.MapMove(0, -200);
				PB_MainMap.Refresh();
				break;

			case Keys.Down:
				PB_MainMap.MapMove(0, 200);
				PB_MainMap.Refresh();
				break;

			case Keys.Left:
				PB_MainMap.MapMove(-300, 0);
				PB_MainMap.Refresh();
				break;

			case Keys.Right:
				PB_MainMap.MapMove(300, 0);
				PB_MainMap.Refresh();
				break;
			}
		}

		//------------------------------------------------------
		//		v^ݒ
		//--------------------------------------------------------
		private void MI_PrinterSet_Click(object sender, EventArgs e)
		{
			pageSetupDialog1.ShowDialog();
		}

		//------------------------------------------------------
		//		n}̈
		//--------------------------------------------------------
		private void MI_MapPrint_Click(object sender, EventArgs e)
		{
			printDocument1.DefaultPageSettings.Landscape = true;
			printDocument1.Print();
		}

		//--------------------------------------------------------
		//		n}̈
		//--------------------------------------------------------
		private void printDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
		{
			PB_MainMap.MapPrint(e.Graphics);
		}

		//--------------------------------------------------------
		//		n}̈vr[
		//--------------------------------------------------------
		private void MI_MapPrintPreview_Click(object sender, EventArgs e)
		{
			printPreviewDialog1.ShowDialog();
		}

		private void MI_AppExit_Click(object sender, EventArgs e)
		{
			Close();
		}
	}
}